
FX_VIDEO_CONTROL equ    0x40
FX_VC            equ    FX_VIDEO_CONTROL
VC_XDL_ENABLED  equ     1
VC_XCOLOR       equ     2
VC_NTR          equ     4
VC_NO_TRANS     equ     VC_NTR
VC_TRANS15      equ     8

; XDL Address
FX_XDL_ADR0     equ     0x41
FX_XDL_ADR1     equ     0x42
FX_XDL_ADR2     equ     0x43

; MEMAC-A / MEMAC-B registers
FX_MEMAC_B_CONTROL equ     0x5d
FX_MEMB            equ     FX_MEMAC_B_CONTROL
FX_MEMAC_CONTROL   equ     0x5e
FX_MEMC            equ     FX_MEMAC_CONTROL
FX_MEMAC_BANK_SEL  equ     0x5f
FX_MEMS            equ     FX_MEMAC_BANK_SEL

; XDLC bits
XDLC_TMON       equ     1
XDLC_GMON       equ     2
XDLC_OVOFF      equ     4
XDLC_MAPON      equ     8
XDLC_MAPOFF     equ     0x10
XDLC_RPTL       equ     0x20
XDLC_OVADR      equ     0x40
XDLC_OVSCRL     equ     0x80
XDLC_CHBASE     equ     0x100
XDLC_MAPADR     equ     0x200
XDLC_MAPPAR     equ     0x400
XDLC_OVATT      equ     0x800
XDLC_ATT        equ     0x800
XDLC_HR         equ     0x1000
XDLC_LR         equ     0x2000
XDLC_END        equ     0x8000

MAXSIZE = 4
EOL	= $9B
@buf	= $0400		; lo addr = 0 !!!

.struct	s@file
pfname	.word		; pointer to string with filename
record	.word		; record size
chanel	.byte		; channel *$10
eof	.byte		; EOF status
buffer	.word		; load/write buffer
nrecord	.word		; number of records for load/write
numread	.word		; pointer to variable, length of loaded data
.ends

.struct	s@xdlc
XDLC	.word
RPTL	.byte
MAPADR	.long
MAPSTEP	.word
HSCROLL	.byte
VSCROLL	.byte
WIDTH	.byte
HEIGHT	.byte
OVWIDTH	.byte
OVPRIOR	.byte
.ends


.macro	m@index2 (Ofset)
	asl STACKORIGIN-%%Ofset,x
	rol STACKORIGIN-%%Ofset+STACKWIDTH,x
.endm

.macro	m@index4 (Ofset)
	asl STACKORIGIN-%%Ofset,x
	rol STACKORIGIN-%%Ofset+STACKWIDTH,x
	asl STACKORIGIN-%%Ofset,x
	rol STACKORIGIN-%%Ofset+STACKWIDTH,x
.endm

	opt l-
	icl 'atari.hea'
	opt l+


tsign	dta 0,$80,0


.proc	hiBYTE
	lda STACKORIGIN,x
	:4 lsr @
	sta STACKORIGIN,x
	rts
.endp

.proc	hiWORD
	lda STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN,x
	rts
.endp

.proc	hiCARD
	lda STACKORIGIN+STACKWIDTH*3,x
	sta STACKORIGIN+STACKWIDTH,x

	lda STACKORIGIN+STACKWIDTH*2,x
	sta STACKORIGIN,x
	rts
.endp


.proc	movaBX_EAX		; mov [BX], EAX
	:MAXSIZE mva eax+# STACKORIGIN-1+#*STACKWIDTH,x
	rts
.endp

/*
.proc	@pushBYTE
	adc STACKORIGIN+STACKWIDTH,x
	sta bp+1

	mva (bp),y STACKORIGIN,x

;	lda #$00
;	sta STACKORIGIN+STACKWIDTH,x
;	sta STACKORIGIN+STACKWIDTH*2,x
;	sta STACKORIGIN+STACKWIDTH*3,x

	rts
.endp
*/

.proc	@pullWORD (.word ya) .reg
	add STACKORIGIN-1,x
	sta bp2
	tya
	adc STACKORIGIN-1+STACKWIDTH,x
	sta bp2+1

	ldy #$00

	mva STACKORIGIN,x (bp2),y
	iny
	mva STACKORIGIN+STACKWIDTH,x (bp2),y

	rts
.endp


.proc	@pullCARD (.word ya) .reg
	add STACKORIGIN-1,x
	sta bp2
	tya
	adc STACKORIGIN-1+STACKWIDTH,x
	sta bp2+1

	ldy #$00

	mva STACKORIGIN,x (bp2),y
	iny
	mva STACKORIGIN+STACKWIDTH,x (bp2),y
	iny
	mva STACKORIGIN+STACKWIDTH*2,x (bp2),y
	iny
	mva STACKORIGIN+STACKWIDTH*3,x (bp2),y

	rts
.endp

.proc	@pushWORD (.word ya) .reg
	add STACKORIGIN,x
	sta bp2
	tya
	adc STACKORIGIN+STACKWIDTH,x
	sta bp2+1

	ldy #$00

	mva (bp2),y STACKORIGIN,x
	iny
	mva (bp2),y STACKORIGIN+STACKWIDTH,x

	rts
.endp


.proc	@pushCARD (.word ya) .reg
	add STACKORIGIN,x
	sta bp2
	tya
	adc STACKORIGIN+STACKWIDTH,x
	sta bp2+1

	ldy #$00

	mva (bp2),y STACKORIGIN,x
	iny
	mva (bp2),y STACKORIGIN+STACKWIDTH,x
	iny
	mva (bp2),y STACKORIGIN+STACKWIDTH*2,x
	iny
	mva (bp2),y STACKORIGIN+STACKWIDTH*3,x

	rts
.endp


.proc	shlEAX_CL

SHORT	jsr @expandToCARD1.SHORT
	jmp CARD

SMALL	jsr @expandToCARD1.SMALL
	jmp CARD

BYTE	lda #0
	sta STACKORIGIN-1+STACKWIDTH,x

WORD	lda #0
	sta STACKORIGIN-1+STACKWIDTH*2,x
	sta STACKORIGIN-1+STACKWIDTH*3,x

CARD	clc
	ldy STACKORIGIN,x	; cl
	beq stop
@	asl STACKORIGIN-1,x	; eax
	rol STACKORIGIN-1+STACKWIDTH,x
	rol STACKORIGIN-1+STACKWIDTH*2,x
	rol STACKORIGIN-1+STACKWIDTH*3,x
	dey
	bne @-

stop	rts
.endp


.proc	shrAL_CL

SHORT	jsr @expandToCARD1.SHORT
	jmp shrEAX_CL

BYTE	ldy STACKORIGIN,x	; cl
	beq stop
@	lsr STACKORIGIN-1,x
	dey
	bne @-

stop	rts
.endp

.proc	shrAX_CL

SMALL	jsr @expandToCARD1.SMALL
	jmp shrEAX_CL

WORD	ldy STACKORIGIN,x	; cl
	beq stop
@	lsr STACKORIGIN-1+STACKWIDTH,x
	ror STACKORIGIN-1,x
	dey
	bne @-

stop	rts
.endp

.proc	shrEAX_CL

	ldy STACKORIGIN,x	; cl
	beq stop
@	lsr STACKORIGIN-1+STACKWIDTH*3,x
	ror STACKORIGIN-1+STACKWIDTH*2,x
	ror STACKORIGIN-1+STACKWIDTH,x
	ror STACKORIGIN-1,x
	dey
	bne @-

stop	rts
.endp

; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; wynik operacji ADD zostanie potraktowany jako INTEGER / CARDINAL
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
.proc	addAL_CL

	ldy #0

	sty STACKORIGIN-1+STACKWIDTH*2,x
	sty STACKORIGIN-1+STACKWIDTH*3,x

	lda STACKORIGIN-1,x
	add STACKORIGIN,x
	sta STACKORIGIN-1,x
	scc
	iny

	sty STACKORIGIN-1+STACKWIDTH,x

	rts
.endp

.proc	addAX_CX

	ldy #0

	sty STACKORIGIN-1+STACKWIDTH*3,x

	lda STACKORIGIN-1,x
	add STACKORIGIN,x
	sta STACKORIGIN-1,x

	lda STACKORIGIN-1+STACKWIDTH,x
	adc STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN-1+STACKWIDTH,x
	scc
	iny

	sty STACKORIGIN-1+STACKWIDTH*2,x

	rts
.endp


.proc	addEAX_ECX

SHORT	jsr @expandToCARD.SHORT
	jsr @expandToCARD1.SHORT
	jmp CARD

SMALL	jsr @expandToCARD.SMALL
	jsr @expandToCARD1.SMALL

CARD	lda STACKORIGIN-1,x
	add STACKORIGIN,x
	sta STACKORIGIN-1,x

	lda STACKORIGIN-1+STACKWIDTH,x
	adc STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN-1+STACKWIDTH,x

	lda STACKORIGIN-1+STACKWIDTH*2,x
	adc STACKORIGIN+STACKWIDTH*2,x
	sta STACKORIGIN-1+STACKWIDTH*2,x

	lda STACKORIGIN-1+STACKWIDTH*3,x
	adc STACKORIGIN+STACKWIDTH*3,x
	sta STACKORIGIN-1+STACKWIDTH*3,x

	rts
.endp

.proc	subAL_CL

	lda STACKORIGIN-1,x
	sub STACKORIGIN,x
	sta STACKORIGIN-1,x

	rts
.endp

.proc	subAX_CX

	lda STACKORIGIN-1,x		; ax
	sub STACKORIGIN,x		; cx
	sta STACKORIGIN-1,x

	lda STACKORIGIN-1+STACKWIDTH,x
	sbc STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN-1+STACKWIDTH,x

	rts
.endp

.proc	subEAX_ECX

	lda STACKORIGIN-1,x
	sub STACKORIGIN,x
	sta STACKORIGIN-1,x

	lda STACKORIGIN-1+STACKWIDTH,x
	sbc STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN-1+STACKWIDTH,x

	lda STACKORIGIN-1+STACKWIDTH*2,x
	sbc STACKORIGIN+STACKWIDTH*2,x
	sta STACKORIGIN-1+STACKWIDTH*2,x

	lda STACKORIGIN-1+STACKWIDTH*3,x
	sbc STACKORIGIN+STACKWIDTH*3,x
	sta STACKORIGIN-1+STACKWIDTH*3,x

	rts
.endp


.proc	@expandSHORT2SMALL
	ldy #$00
	lda STACKORIGIN,x
	spl
	dey
	sty STACKORIGIN+STACKWIDTH,x

	rts
.endp

.proc	@expandSHORT2SMALL1
	ldy #$00
	lda STACKORIGIN-1,x
	spl
	dey
	sty STACKORIGIN-1+STACKWIDTH,x

	rts
.endp


.proc	@expandToCARD
/*
SLONG	lda STACKORIGIN+STACKWIDTH*2,x
	bpl LONG

	lda #$ff
	bne _lo

LONG	lda #$00
	beq _lo
*/
SMALL	lda STACKORIGIN+STACKWIDTH,x
	bpl WORD

	lda #$ff
	bne _wo

WORD	lda #$00
	beq _wo

SHORT	lda STACKORIGIN,x
	bpl BYTE

	lda #$ff
	bne _by

BYTE	lda #$00

_by	sta STACKORIGIN+STACKWIDTH,x
_wo	sta STACKORIGIN+STACKWIDTH*2,x
_lo	sta STACKORIGIN+STACKWIDTH*3,x
	rts
.endp


.proc	@expandToCARD1
/*
SLONG	lda STACKORIGIN-1+STACKWIDTH*2,x
	bpl LONG

	lda #$ff
	bne _lo

LONG	lda #$00
	beq _lo
*/
SMALL	lda STACKORIGIN-1+STACKWIDTH,x
	bpl WORD

	lda #$ff
	bne _wo

WORD	lda #$00
	beq _wo

SHORT	lda STACKORIGIN-1,x
	bpl BYTE

	lda #$ff
	bne _by

BYTE	lda #$00
	
_by	sta STACKORIGIN-1+STACKWIDTH,x
_wo	sta STACKORIGIN-1+STACKWIDTH*2,x
_lo	sta STACKORIGIN-1+STACKWIDTH*3,x
	rts
.endp

/*
.proc	@cmpFor_WORD (.word ya) .reg
	sta ztmp
	sty ztmp+1

	ldy #1
	lda (ztmp),y
	cmp STACKORIGIN+1+STACKWIDTH,x
	bne stop
	dey
	lda (ztmp),y
	cmp STACKORIGIN+1,x
stop	rts
.endp
*/

.proc	@cmpFor_CARD (.word ya) .reg
	sta ztmp
	sty ztmp+1
	
	ldy #3
	lda (ztmp),y
	cmp STACKORIGIN+1+STACKWIDTH*3,x
	bne stop
	dey
	lda (ztmp),y
	cmp STACKORIGIN+1+STACKWIDTH*2,x
	bne stop
	dey
	lda (ztmp),y
	cmp STACKORIGIN+1+STACKWIDTH,x
	bne stop
	dey
	lda (ztmp),y
	cmp STACKORIGIN+1,x

stop	rts
.endp

/*
.proc	@cmpFor_SHORTINT(.word ya) .reg
	sta ztmp
	sty ztmp+1

	ldy	#0
	lda	(ztmp),y
	sec
	sbc	STACKORIGIN+1,x
	bne	@cmpFor_INT.L4

	jmp	@cmpFor_INT.L1
.endp
*/

.proc	@cmpFor_SMALLINT(.word ya) .reg
	sta ztmp
	sty ztmp+1

	ldy	#1
	lda	(ztmp),y
	sec
	sbc	STACKORIGIN+1+STACKWIDTH,x
	bne	@cmpFor_INT.L4

	dey
	lda	(ztmp),y
	cmp	STACKORIGIN+1,x

	jmp	@cmpFor_INT.L1
.endp


.proc	@cmpFor_INT(.word ya) .reg
	sta ztmp
	sty ztmp+1

	ldy	#3
	lda	(ztmp),y
	sec
	sbc	STACKORIGIN+1+STACKWIDTH*3,x
	bne	L4

	dey
	lda	(ztmp),y
	cmp	STACKORIGIN+1+STACKWIDTH*2,x
	bne	L1

	dey
	lda	(ztmp),y
	cmp	STACKORIGIN+1+STACKWIDTH,x
	bne	L1

	dey
	lda	(ztmp),y
	cmp	STACKORIGIN+1,x

L1	beq	L2
	bcs	L3

	lda	#$FF	; Set the N flag
L2	rts

L3	lda	#$01	; Clear the N flag
	rts

L4	bvc	L5
	eor	#$FF	; Fix the N flag if overflow
	ora	#$01	; Clear the Z flag
L5	rts
.endp


; Piotr Fusik, 15.04.2002
; originally by Ullrich von Bassewitz

.proc	cmpSHORTINT
	lda	STACKORIGIN-1,x
	sec
	sbc	STACKORIGIN,x
	bne	cmpINT.L4

	jmp	cmpINT.L1
.endp


.proc	cmpSMALLINT
	lda	STACKORIGIN-1+STACKWIDTH,x
	sec
	sbc	STACKORIGIN+STACKWIDTH,x
	bne	cmpINT.L4

	lda	STACKORIGIN-1,x
	cmp	STACKORIGIN,x

	jmp	cmpINT.L1
.endp


.proc	cmpINT
	lda	STACKORIGIN-1+STACKWIDTH*3,x
	sec
	sbc	STACKORIGIN+STACKWIDTH*3,x
	bne	L4

	lda	STACKORIGIN-1+STACKWIDTH*2,x
	cmp	STACKORIGIN+STACKWIDTH*2,x
	bne	L1

	lda	STACKORIGIN-1+STACKWIDTH,x
	cmp	STACKORIGIN+STACKWIDTH,x
	bne	L1

	lda	STACKORIGIN-1,x
	cmp	STACKORIGIN,x

L1	beq	L2
	bcs	L3

	lda	#$FF	; Set the N flag
L2	rts

L3	lda	#$01	; Clear the N flag
	rts

L4	bvc	L5
	eor	#$FF	; Fix the N flag if overflow
	ora	#$01	; Clear the Z flag
L5	rts
.endp


.proc	cmpEAX_ECX
	lda STACKORIGIN-1+STACKWIDTH*3,x
	cmp STACKORIGIN+STACKWIDTH*3,x
	bne _done
	lda STACKORIGIN-1+STACKWIDTH*2,x
	cmp STACKORIGIN+STACKWIDTH*2,x
	bne _done
AX_CX
	lda STACKORIGIN-1+STACKWIDTH,x
	cmp STACKORIGIN+STACKWIDTH,x
	bne _done
	lda STACKORIGIN-1,x
	cmp STACKORIGIN,x

_done	rts
.endp


.proc	notaBX

	.rept MAXSIZE
	lda STACKORIGIN+#*STACKWIDTH,x
	eor #$ff
	sta STACKORIGIN+#*STACKWIDTH,x
	.endr

	rts
.endp


.proc	notBOOLEAN
	lda STACKORIGIN,x
	bne _0

	lda #true
	sne

_0	lda #false
	sta STACKORIGIN,x

	rts
.endp


.proc	negBYTE
	lda #$00
	sub STACKORIGIN,x
	sta STACKORIGIN,x

	rts
.endp

.proc	negWORD
	lda #$00
	sub STACKORIGIN,x
	sta STACKORIGIN,x

	lda #$00
	sbc STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN+STACKWIDTH,x

	rts
.endp

.proc	negCARD
	lda #$00
	sub STACKORIGIN,x
	sta STACKORIGIN,x

	lda #$00
	sbc STACKORIGIN+STACKWIDTH,x
	sta STACKORIGIN+STACKWIDTH,x

	lda #$00
	sbc STACKORIGIN+STACKWIDTH*2,x
	sta STACKORIGIN+STACKWIDTH*2,x

	lda #$00
	sbc STACKORIGIN+STACKWIDTH*3,x
	sta STACKORIGIN+STACKWIDTH*3,x

	rts
.endp


.proc	negBYTE1
	lda #$00
	sub STACKORIGIN-1,x
	sta STACKORIGIN-1,x

	rts
.endp

.proc	negWORD1
	lda #$00
	sub STACKORIGIN-1,x
	sta STACKORIGIN-1,x

	lda #$00
	sbc STACKORIGIN-1+STACKWIDTH,x
	sta STACKORIGIN-1+STACKWIDTH,x

	rts
.endp

.proc	negCARD1
	lda #$00
	sub STACKORIGIN-1,x
	sta STACKORIGIN-1,x

	lda #$00
	sbc STACKORIGIN-1+STACKWIDTH,x
	sta STACKORIGIN-1+STACKWIDTH,x

	lda #$00
	sbc STACKORIGIN-1+STACKWIDTH*2,x
	sta STACKORIGIN-1+STACKWIDTH*2,x

	lda #$00
	sbc STACKORIGIN-1+STACKWIDTH*3,x
	sta STACKORIGIN-1+STACKWIDTH*3,x

	rts
.endp


.proc	andAL_CL

	lda STACKORIGIN-1,x
	and STACKORIGIN,x
	sta STACKORIGIN-1,x

	rts
.endp

.proc	andAX_CX

	.rept 2
	lda STACKORIGIN-1+#*STACKWIDTH,x
	and STACKORIGIN+#*STACKWIDTH,x
	sta STACKORIGIN-1+#*STACKWIDTH,x
	.endr

	rts
.endp

.proc	andEAX_ECX

	.rept MAXSIZE
	lda STACKORIGIN-1+#*STACKWIDTH,x
	and STACKORIGIN+#*STACKWIDTH,x
	sta STACKORIGIN-1+#*STACKWIDTH,x
	.endr

	rts
.endp


.proc	orAL_CL

	lda STACKORIGIN-1,x
	ora STACKORIGIN,x
	sta STACKORIGIN-1,x

	rts
.endp

.proc	orAX_CX

	.rept 2
	lda STACKORIGIN-1+#*STACKWIDTH,x
	ora STACKORIGIN+#*STACKWIDTH,x
	sta STACKORIGIN-1+#*STACKWIDTH,x
	.endr

	rts
.endp

.proc	orEAX_ECX

	.rept MAXSIZE
	lda STACKORIGIN-1+#*STACKWIDTH,x
	ora STACKORIGIN+#*STACKWIDTH,x
	sta STACKORIGIN-1+#*STACKWIDTH,x
	.endr

	rts
.endp


.proc	xorAL_CL

	lda STACKORIGIN-1,x
	eor STACKORIGIN,x
	sta STACKORIGIN-1,x

	rts
.endp

.proc	xorAX_CX

	.rept 2
	lda STACKORIGIN-1+#*STACKWIDTH,x
	eor STACKORIGIN+#*STACKWIDTH,x
	sta STACKORIGIN-1+#*STACKWIDTH,x
	.endr

	rts
.endp

.proc	xorEAX_ECX

	.rept MAXSIZE
	lda STACKORIGIN-1+#*STACKWIDTH,x
	eor STACKORIGIN+#*STACKWIDTH,x
	sta STACKORIGIN-1+#*STACKWIDTH,x
	.endr

	rts
.endp


.proc	iniEAX_ECX_BYTE
	mva STACKORIGIN,x ecx

	mva STACKORIGIN-1,x eax

	mva #$00 ecx+1
	sta ecx+2
	sta ecx+3

	sta eax+1
	sta eax+2
	sta eax+3

	rts
.endp


.proc	iniEAX_ECX_WORD
	mva STACKORIGIN,x ecx
	mva STACKORIGIN+STACKWIDTH,x ecx+1

	mva STACKORIGIN-1,x eax
	mva STACKORIGIN-1+STACKWIDTH,x eax+1

	mva #$00 ecx+2
	sta ecx+3

	sta eax+2
	sta eax+3

	rts
.endp


.proc	iniEAX_ECX_CARD
	mva STACKORIGIN,x ecx
	mva STACKORIGIN+STACKWIDTH,x ecx+1
	mva STACKORIGIN+STACKWIDTH*2,x ecx+2
	mva STACKORIGIN+STACKWIDTH*3,x ecx+3

	mva STACKORIGIN-1,x eax
	mva STACKORIGIN-1+STACKWIDTH,x eax+1
	mva STACKORIGIN-1+STACKWIDTH*2,x eax+2
	mva STACKORIGIN-1+STACKWIDTH*3,x eax+3

	rts
.endp

.proc	movZTMP_aBX
	mva ZTMP8 STACKORIGIN-1,x
	mva ZTMP9 STACKORIGIN-1+STACKWIDTH,x
	mva ZTMP10 STACKORIGIN-1+STACKWIDTH*2,x
	mva ZTMP11 STACKORIGIN-1+STACKWIDTH*3,x

	rts
.endp


.proc	divmulSHORTINT

MOD	mva #{jsr} _mod

	lda STACKORIGIN,x		; divisor sign
	spl
	jsr negBYTE

DIV	ldy <idivAL_CL
	lda >idivAL_CL
	bne skp

MUL	ldy <imulECX.BYTE
	lda >imulECX.BYTE

skp	sty addr
	sta addr+1

	ldy #0

	lda STACKORIGIN-1,x		; dividend sign
	bpl @+
	jsr negBYTE1
	iny

@	lda STACKORIGIN,x		; divisor sign
	bpl @+
	jsr negBYTE
	iny

@	lda tsign,y
	pha

	jsr idivAL_CL			; idiv ecx
addr	equ *-2
	jsr movaBX_EAX

_mod	bit movZTMP_aBX			; mod
	mva #{bit} _mod

	pla
	spl
	jmp negCARD1
	
	rts
.endp


.proc	divmulSMALLINT

MOD	mva #{jsr} _mod

	lda STACKORIGIN+STACKWIDTH,x	; divisor sign
	spl
	jsr negWORD

DIV	ldy <idivAX_CX
	lda >idivAX_CX
	bne skp

MUL	ldy <imulECX.WORD
	lda >imulECX.WORD

skp	sty addr
	sta addr+1

	ldy #0

	lda STACKORIGIN-1+STACKWIDTH,x	; dividend sign
	bpl @+
	jsr negWORD1
	iny

@	lda STACKORIGIN+STACKWIDTH,x	; divisor sign
	bpl @+
	jsr negWORD
	iny

@	lda tsign,y
	pha

	jsr idivAX_CX			; idiv cx
addr	equ *-2
	jsr movaBX_EAX

_mod	bit movZTMP_aBX			; mod
	mva #{bit} _mod

	pla
	spl
	jmp negCARD1
	
	rts
.endp


.proc	divmulINT

REAL	ldy <divREAL
	lda >divREAL
	bne skp

MOD	mva #{jsr} _mod

	lda STACKORIGIN+STACKWIDTH*3,x		; divisor sign
	spl
	jsr negCARD

DIV	ldy <idivEAX_ECX.CARD
	lda >idivEAX_ECX.CARD
	bne skp

MUL	ldy <imulECX.CARD
	lda >imulECX.CARD

skp	sty addr
	sta addr+1

	ldy #0

	lda STACKORIGIN-1+STACKWIDTH*3,x		; dividend sign
	bpl @+
	jsr negCARD1
	iny

@	lda STACKORIGIN+STACKWIDTH*3,x		; divisor sign
	bpl @+
	jsr negCARD
	iny

@	lda tsign,y
	pha

	jsr idivEAX_ECX				; idiv ecx
addr	equ *-2
	jsr movaBX_EAX

_mod	bit movZTMP_aBX				; mod
	mva #{bit} _mod

	pla
	spl
	jmp negCARD1
	
	rts
.endp


;32 bit multiply with 64 bit product

.proc	imul64

	jsr iniEAX_ECX_CARD

	lda #$00
	sta edx		;Clear upper half of
	sta edx+1	;product
	sta edx+2
	sta edx+3

	sta ztmp8
	sta ztmp9
	sta ztmp10
	sta ztmp11

	ldy #$20	;Set binary count to 32
SHIFT_R	lsr eax+3	;Shift multiplyer right
	ror eax+2
	ror eax+1
	ror eax
	bcc ROTATE_R	;Go rotate right if c = 0
	lda edx		;Get upper half of product
	clc		;and add multiplicand to
	adc ecx		;it
	sta edx
	lda edx+1
	adc ecx+1
	sta edx+1
	lda edx+2
	adc ecx+2
	sta edx+2
	lda edx+3
	adc ecx+3
ROTATE_R  ror @		;Rotate partial product
        sta edx+3	;right
        ror edx+2
        ror edx+1
        ror edx
        ror ztmp11
        ror ztmp10
        ror ztmp9
        ror ztmp8
        dey		;Decrement bit count and
        bne SHIFT_R	;loop until 32 bits are

	mva ztmp8 eax
	mva ztmp9 eax+1
	mva ztmp10 eax+2
	mva ztmp11 eax+3

	rts
.endp


.proc	mulREAl
	ldy #0

	lda STACKORIGIN-1+STACKWIDTH*3,x	; dividend sign
	bpl @+
	jsr negCARD1
	iny

@	lda STACKORIGIN+STACKWIDTH*3,x		; divisor sign
	bpl @+
	jsr negCARD
	iny

@	lda tsign,y
	pha
	
	jsr imul64			; imul ecx 64 bit

	mva eax+1 eax
	mva eax+2 eax+1
	mva eax+3 eax+2
	mva edx eax+3

	jsr movaBX_EAX	

	pla
	spl

	jmp negCARD1

	rts
.endp


/*

 8 bit multiply and divide routines.
 Three 8 bit locations
 ACC, AUX and EXT must be set up,
 preferably on zero page.

 MULTIPLY ROUTINE

 EAX*ECX -> EAX (low,hi) 16 bit result

*/

.proc	imulCL

;	LDA #0

	LDY #$09
	CLC
LOOP	ROR @
	ROR eax
	BCC MUL2
	CLC		;DEC AUX above to remove CLC
	ADC ecx
MUL2	DEY
	BNE LOOP

	STA eax+1

	RTS
.endp


/*

 16 bit multiply and divide routines.
 Three 16 bit (two-byte) locations
 ACC, AUX and EXT must be set up,
 preferably on zero page.

 MULTIPLY ROUTINE

 EAX*ECX -> EAX (low,hi) 32 bit result

*/

.proc	imulCX

	LDA #0

	LDY #$11
	CLC
LOOP	ROR eax+3
	ROR @
	ROR eax+1
	ROR eax
	BCC MUL2
	CLC
	ADC ecx
	PHA
	LDA ecx+1
	ADC eax+3
	STA eax+3
	PLA
MUL2	DEY
	BNE LOOP

	STA eax+2

	rts
.endp


; *** MUL32: 32-bit multiply 
; EAX * ECX -> ZTMP8-ZTMP11
.proc	imulECX

BYTE	jsr iniEAX_ECX_BYTE
	jmp imulCL
;	beq main_
WORD	jsr iniEAX_ECX_WORD
	jmp imulCX
;	beq main_
CARD	jsr iniEAX_ECX_CARD

main	lda #0
main_	sta ZTMP10
	sta ZTMP9
	sta ZTMP8

	ldy #32
MUL320	lsr ZTMP10
	ror ZTMP9
	ror ZTMP8
	ror @
	ror eax+3
	ror eax+2
	ror eax+1
	ror eax
	bcc MUL321
	clc
	adc ecx
	pha
	lda ecx+1
	adc ZTMP8
	sta ZTMP8
	lda ecx+2
	adc ZTMP9
	sta ZTMP9
	lda ecx+3
	adc ZTMP10
	sta ZTMP10
	pla
MUL321	dey
       	bpl MUL320

	rts
.endp


; *** UDIV32: 32-bit unsigned division 
; input: dividend at ZTMP0-ZTMP3 
;        divisor at ZTMP4-ZTMP7 
; output: result at ZTMP0-ZTMP3 
;         remainder at ZTMP8-ZTMP11 
; X,Y preserved
.proc	idivEAX_ECX

REAL	mva STACKORIGIN-1+STACKWIDTH*2,x STACKORIGIN-1+STACKWIDTH*3,x
	mva STACKORIGIN-1+STACKWIDTH,x STACKORIGIN-1+STACKWIDTH*2,x
	mva STACKORIGIN-1,x STACKORIGIN-1+STACKWIDTH,x
	mva #$00 STACKORIGIN-1,x

CARD	jsr iniEAX_ECX_CARD

MAIN	LDA #0
	STA ZTMP8
	STA ZTMP9
	STA ZTMP10
	STA ZTMP11

	LDY #32
UDIV320	ASL eax
	ROL eax+1
	ROL eax+2
	ROL eax+3
	ROL ZTMP8
	ROL ZTMP9
	ROL ZTMP10
	ROL ZTMP11
			;do a subtraction 
	LDA ZTMP8
	CMP ecx
	LDA ZTMP9
	SBC ecx+1
	LDA ZTMP10
	SBC ecx+2
	LDA ZTMP11
	SBC ecx+3
	BCC UDIV321
 			;overflow, do the subtraction again, this time store the result 
	STA ecx+3	;we have the high byte already 
	LDA ZTMP8
	SBC ecx		;byte 0 
	STA ZTMP8
	LDA ZTMP9
	SBC ecx+1
	STA ZTMP9	;byte 1 
	LDA ZTMP10
	SBC ecx+2
	STA ZTMP10	;byte 2 
	INC eax		;set result bit 
 
UDIV321	DEY
	BNE UDIV320

	rts
.endp


; 64bit / 32bit = 32bit
; eax = eax + edx
.proc	divREAL

	jsr iniEAX_ECX_CARD

	mva eax+3 eax+4
	mva eax+2 eax+3
	mva eax+1 eax+2
	mva eax eax+1

	lda #$00
	sta eax
	sta eax+5
	sta eax+6
	sta eax+7

	STA ZTMP8
	STA ZTMP9
	STA ZTMP10
	STA ZTMP11

	LDY #64
UDIV320	ASL eax
	ROL eax+1
	ROL eax+2
	ROL eax+3
	ROL eax+4
	ROL eax+5
	ROL eax+6
	ROL eax+7

	ROL ZTMP8
	ROL ZTMP9
	ROL ZTMP10
	ROL ZTMP11
			;do a subtraction 
	LDA ZTMP8
	CMP ecx
	LDA ZTMP9
	SBC ecx+1
	LDA ZTMP10
	SBC ecx+2
	LDA ZTMP11
	SBC ecx+3
	BCC UDIV321
 			;overflow, do the subtraction again, this time store the result 
	STA ecx+3	;we have the high byte already 
	LDA ZTMP8
	SBC ecx		;byte 0 
	STA ZTMP8
	LDA ZTMP9
	SBC ecx+1
	STA ZTMP9	;byte 1 
	LDA ZTMP10
	SBC ecx+2
	STA ZTMP10	;byte 2 
	
	INC eax		;set result bit 
 
UDIV321	DEY
	BNE UDIV320

	rts
.endp


; DIVIDE ROUTINE (16 BIT)
; AX/CX -> ACC, remainder in ZTMP

.proc	idivAX_CX

	jsr iniEAX_ECX_WORD

main
;	LDA #0
	STA ztmp+1
	STA ztmp+2
	STA ztmp+3

	LDY #$10

LOOP	ASL ax
	ROL ax+1
	ROL @
	ROL ztmp+1
	PHA
	CMP cx
	LDA ztmp+1
	SBC cx+1
	BCC DIV2
	STA ztmp+1
	PLA
	SBC cx
	PHA
	INC ax
DIV2	PLA
	DEY
	BNE LOOP

	STA ztmp

	rts
.endp


; DIVIDE ROUTINE (8 BIT)
; AL/CL -> ACC, remainder in ZTMP

.proc idivAL_CL

	jsr iniEAX_ECX_BYTE

	STA ZTMP+1
	STA ZTMP+2
	STA ZTMP+3

	LDY #$08
LOOP	ASL AL
	ROL @
	CMP CL
	BCC DIV2
	SBC CL
	INC AL
DIV2
	DEY
	BNE LOOP

	STA ZTMP

	rts
.endp


.proc	@printCHAR
	ldy STACKORIGIN,x
	jmp @print
.endp


.proc	@print (.byte y) .reg
	txa:pha

	tya
	jsr @putchar

	pla:tax
	rts
.endp


.proc	@printSTRING (.word ya) .reg
	sta ztmp
	sty ztmp+1

	stx @sp

	ldy #0
	sty loop+1
	lda (ztmp),y
	sta ln

	inw ztmp

loop	ldy #0
	lda (ztmp),y

	cpy #0
ln	equ *-1
	beq stop

	iny
	sty loop+1

	@putchar @

	jmp loop

stop	ldx #0
@sp	equ *-1
	rts
.endp


.proc	@printBOOLEAN
	lda STACKORIGIN,x
	beq _0

_1	lda <_true
	ldy >_true
	jmp @printSTRING	
	
_0	lda <_false
	ldy >_false
	jmp @printSTRING	

_true	dta 4,c'TRUE'
_false	dta 5,c'FALSE'	
.endp


.proc	mov_BYTE_DX
	mva STACKORIGIN,x dx
	mva #$00 dx+1
	sta dx+2
	sta dx+3

	rts
.endp

.proc	mov_WORD_DX
	mva STACKORIGIN,x dx
	mva STACKORIGIN+STACKWIDTH,x dx+1
	mva #$00 dx+2
	sta dx+3

	rts
.endp

.proc	mov_CARD_DX
	mva STACKORIGIN,x dx
	mva STACKORIGIN+STACKWIDTH,x dx+1
	mva STACKORIGIN+STACKWIDTH*2,x dx+2
	mva STACKORIGIN+STACKWIDTH*3,x dx+3

	rts
.endp


.proc	@printREAL
	txa:pha

	lda STACKORIGIN+STACKWIDTH*3,x
	bpl plus

	ldy #'-'
	jsr @printVALUE.pout

	jsr negCARD

plus	jsr mov_CARD_DX

	mva dx+1 intpart		; intpart := uvalue shr 8
	mva dx+2 intpart+1
	mva dx+3 intpart+2
	mva #$00 intpart+3

	sta dx+3			; fracpart := uvalue and $FF (dx)
	sta dx+2
	sta dx+1

	sta fracpart+3

	jsr fmul10		; scale = 10 x 10 = 100
	jsr fmul10		; fracpart := fracpart * scale

	mva dx+1 fracpart
	mva dx+2 fracpart+1
	mva dx+3 fracpart+2

;	lda dx			; fracpart := (product) shr 8 + (product and $80) shr 7
;	spl
;	ind fracpart

	sec			; = true
	itoa_loop intpart #1000000

	ldy #'.'
	jsr @printVALUE.pout

	clc			; = false
	itoa_loop fracpart #100/10

	pla:tax
	rts


.proc	itoa_loop (.dword value, dx) .var

	adc #0
	sta skip

while	lda dx				; scale
	jeq stop

	mwa value ax			; digit := (value div scale);
	mwa value+2 ax+2
	mwa dx cx
	mwa dx+2 cx+2
	jsr idivEAX_ECX.main		; ax = digit

		lda #0			; skip := false
	skip:	equ *-1
		beq ok

		lda ax			; digit > 0
		bne ok

		lda dx
		cmp #1			; scale = 1
		bne skp
		
	ok:	mva #false skip							

		mwa ztmp value		; value := value mod scale
		mwa ztmp+2 value+2
	
		lda ax			; print chr(digit + ord('0'))
		ora #$30
		tay
		jsr @printVALUE.pout
	skp:
	
	jsr div10			; scale := scale div 10;

	jmp while

stop	rts
.endp

fracpart	.dword
intpart		.dword
value		.dword

.endp


.proc	@printSHORTINT

	lda STACKORIGIN,x
	bpl ok

	ldy #'-'
	jsr @printVALUE.pout

	jsr negCARD

ok	jsr mov_BYTE_DX

	jmp @printVALUE
.endp


.proc	@printSMALLINT

	lda STACKORIGIN+STACKWIDTH,x
	bpl ok

	ldy #'-'
	jsr @printVALUE.pout

	jsr negCARD

ok	jsr mov_WORD_DX

	jmp @printVALUE
.endp


.proc	@printINT

	lda STACKORIGIN+STACKWIDTH*3,x
	bpl ok

	ldy #'-'
	jsr @printVALUE.pout

	jsr negCARD

ok	jsr mov_CARD_DX

	jmp @printVALUE
.endp


.proc	@printCARD
	jsr mov_CARD_DX
	jmp @printVALUE
.endp


.proc	@printWORD
	jsr mov_WORD_DX
	jmp @printVALUE
.endp


.proc	@printBYTE
	jsr mov_BYTE_DX
	jmp @printVALUE
.endp


.proc	@printVALUE

	stx @sp

	lda dx+3
	bne _32bit

	lda dx+2
	bne _24bit

	lda dx+1
	bne _16bit

_8bit	lda #3
	bne l3

_16bit	lda #5
	bne l3

_24bit	lda #8	
	bne l3

	; prints a 32 bit value to the screen (Graham)

_32bit	lda #10

l3	sta limit

	ldx #0

lp	jsr div10

	sta tmp,x
	inx
	cpx #10
limit	equ *-1
	bne lp

	;ldx #9
	dex

l1	lda tmp,x
	bne l2
	dex		; skip leading zeros
	bne l1

l2	lda tmp,x
	ora #$30
	tay

	jsr pout

	dex
	bpl l2

	mva #{jmp*} pout
       
	ldx #0
@sp	equ *-1
	rts


pout	jmp @print

	sty @buf+1
pbuf	equ *-2
	inc pbuf

	rts

tmp	.byte 0,0,0,0,0,0,0,0,0,0

.endp


; divides a 32 bit value by 10
; remainder is returned in akku

.proc	div10
        ldy #32		; 32 bits
        lda #0
        clc
l4      rol @
        cmp #10
        bcc skip
        sbc #10
skip    rol dx
        rol dx+1
        rol dx+2
        rol dx+3
        dey
        bpl l4

	rts
.endp


.proc	@hexStr

Value	= edx
Digits	= ecx

	ldx Digits
	cpx #32
	scc
	ldx #32

	stx Digits

	lda Value
	jsr hex
	lda Value+1
	jsr hex
	lda Value+2
	jsr hex
	lda Value+3
	jsr hex

	lda Digits
	sta @buf
	rts

hex	pha
	and #$f
	jsr put
	pla
	:4 lsr @
put	tay
	lda thex,y
	sta @buf,x
	dex
	rts

thex	dta c'0123456789ABCDEF'
.endp


.proc	@ValueToStr (.word ya) .reg

	sta adr
	sty adr+1

	mva #{bit*} @printVALUE.pout
	mva <@buf+1 @printVALUE.pbuf

	jsr $ffff
adr	equ *-2

	ldy @printVALUE.pbuf
	dey
	sty @buf

	rts
.endp


;	ecx	isSign
;	edx	Result

.proc	@StrToInt (.word ya) .reg

	sta bp2
	sty bp2+1

	ldy #0
	sty edx
	sty edx+1
	sty edx+2
	sty edx+3

	lda (bp2),y
	sta len

	inw bp2

	lda (bp2),y
	cmp #'-'
	sne
	iny

	sty ecx

l1	lda (bp2),y

	CLC
	ADC #$FF-'9'	; make m = $FF
	ADC #'9'-'0'+1	; carry set if in range n to m
	bcs ok

	rts		; reg Y contains the index of the character in S which prevented the conversion

ok	jsr fmul10

	lda (bp2),y
	sub #$30
	sta ztmp

	lda #$00
	sta ztmp+1
	sta ztmp+2
	sta ztmp+3

	jsr fmul10.add32bit

	iny
	cpy #0
len	equ *-1
	bne l1

	lda ecx
	beq stop

	jsr negEDX

stop	ldy #0		; reg Y = 0 conversion successful
	rts
.endp


.proc	negEDX
	lda #$00		; minus
	sub edx
	sta edx

	lda #$00
	sbc edx+1
	sta edx+1

	lda #$00
	sbc edx+2
	sta edx+2

	lda #$00
	sbc edx+3
	sta edx+3

	rts
.endp


.proc	fmul10
	asl edx		;multiply by 2
	rol edx+1	;temp store in ZTMP
	rol edx+2
	rol edx+3

	lda edx
	sta ztmp
	lda edx+1
	sta ztmp+1
	lda edx+2
	sta ztmp+2
	lda edx+3
	sta ztmp+3

	asl edx
	rol edx+1
	rol edx+2
	rol edx+3

	asl edx
	rol edx+1
	rol edx+2
	rol edx+3

add32bit
	lda edx
	add ztmp
	sta edx
	lda edx+1
	adc ztmp+1
	sta edx+1
	lda edx+2
	adc ztmp+2
	sta edx+2
	lda edx+3
	adc ztmp+3
	sta edx+3

	rts
.endp


.proc	@round

	ldy edx+3
	spl
	jsr negEDX

	lda edx
	pha

	mva edx+1 edx
	mva edx+2 edx+1
	mva edx+3 edx+2
	mva #0 edx+3
	
	pla
	spl
	ind edx

	tya
	spl
	jmp negEDX

	rts
.endp


.proc	@trunc

	ldy edx+3
	spl
	jsr negEDX

	mva edx+1 edx
	mva edx+2 edx+1
	mva edx+3 edx+2
	mva #0 edx+3

	tya
	spl
	jmp negEDX

	rts
.endp


.proc	@frac

	ldy edx+3
	spl
	jsr negEDX

	mva #0 edx+1
	sta edx+2
	sta edx+3
	
	tya
	spl
	jmp negEDX

	rts
.endp


;----------------------------;
; Biblioteka procedur        ;
; graficznych                ;
;----------------------------;
; Autorzy:                   ;
;  Slawomir 'SERO' Ritter,   ;
;  Jakub Cebula,             ;
;  Winfried Hofacker         ;
;----------------------------;
; Wersja:1.1 DATA:09.01.2008 ;
;----------------------------;

@open	= $03		; Otworz kanal
@close	= $0c		; Zamknij kanal

@IDget	= $07		; Narysuj punkt
@IDput	= $09		; Narysuj punkt
@IDdraw	= $11		; Narysuj linie
@IDfill	= $12		; Wypelnij obszar


;------------------------;
;Wy:.Y-numer bledu (1-OK);
;   f(N)=1-wystapil blad ;
;------------------------;
.proc	@COMMAND

	ldx	#$00
scrchn	equ *-1

	sta	iocom,x

	lda	#$00
colscr	equ *-1
	sta	atachr

	jmp	ciov

stop	rts
.endp

;------------------------;
; Ustaw tryb ekranu      ;
;------------------------;
;We:.X-numer kanalu      ;
;      (normalnie 0)     ;
;   .Y-numer trybu (O.S.);
;   .A-Ustawiony bit nr :;
;     5-Nie kasowanie    ;
;       pamieci ekranu   ;
;     4-Obecnosc okna    ;
;       tekstowego       ;
;     2-Odczyt z ekranu  ;
;------------------------;
;Wy:SCRCHN-numer kanalu  ;
;  .Y-numer bledu (1-OK) ;
;   f(N)=1 wystapil blad ;
;------------------------;
@GRAPHICS .proc (.byte x,y,a) .reg

	sta	byte1
	sty	byte2

	stx	@COMMAND.scrchn

	mva	#@close	iocom,x
	jsr	ciov

	lda	#0		; =opcje
byte1	equ	*-1
	ora	#8		; +zapis na ekranie
	sta	ioaux1,x

	lda	#0
byte2	equ	*-1
	sta	ioaux2,x	;=nr.trybu

	mva	#@open	iocom,x

	mwa	#scrnam	ioadr,x

	jmp	ciov

scrnam   dta c'S:',$9b

	.endp


/*
  PUT CHAR

  Procedura wyprowadza znak na ekran na pozycji X/Y kursora okreslonej przez zmienne odpowiednio
  COLCRS ($55-$56) i ROWCRS ($54). Zaklada sie, ze obowiazuja przy tym domyslne ustawienia OS-u,
  to jest ekran jest w trybie Graphics 0, a kanal IOCB 0 jest otwarty dla edytora ekranowego. 

  Wyprowadzenie znaku polega na zaladowaniu jego kodu ATASCII do akumulatora i wykonaniu rozkazu
  JSR PUTCHR. 
*/

.proc	@putchar (.byte a) .reg

vbxe	bit *

	ldx #$00
	.ifdef MAIN.CRT.TextAttr
	ora MAIN.CRT.TextAttr
	.endif
	tay
	lda icputb+1,x
	pha
	lda icputb,x
	pha
	tya

	rts

.endp


/*
  GETLINE

  Program czeka, az uzytkownik wpisze ciag znakw z klawiatury i nacisnie klawisz RETURN.
  Znaki podczas wpisywania sa wyswietlane na ekranie, dzialaja tez normalne znaki kontrolne
  (odczyt jest robiony z edytora ekranowego).

  Wywolanie funkcji polega na zaladowaniu adresu, pod jaki maja byc wpisane znaki,
  do rejestrw A/Y (mlodszy/starszy) i wykonaniu rozkazu JSR GETLINE.

*/

.proc	@getline

	stx @sp

	ldx #0

	mwa	#@buf+1	icbufa,x

	mwa	#$ff	icbufl,x	; maks. wielkosc tekstu

	mva	#$05	iccmd,x

	jsr	ciov

	dew icbufl
	mva icbufl @buf			; length

	ldx #0
@sp	equ *-1

	rts
.endp


.proc	@GetKey

getk	lda kbcodes	; odczytaj kbcodes
	cmp #255		; czy jest znak?
	beq getk	; nie: czekaj
	ldy #255		; daj zna, e klawisz
	sty kbcodes	; zosta odebrany
	tay		; kod klawisza jako indeks
	lda (keydef),y	; do tablicy w ROM-ie

	rts
.endp


.proc	@moveSTRING (.word ya) .reg

	sta @move.dst
	sty @move.dst+1

	mva STACKORIGIN,x @move.src
	mva STACKORIGIN+STACKWIDTH,x @move.src+1

	ldy #$00
	lda (@move.src),y
	add #1
	sta @move.cnt
	scc
	iny
	sty @move.cnt+1

	jmp @move
.endp


.proc	@move (.word src, dst, cnt) .var

src	= edx
dst	= ecx
cnt	= eax

	stx @sp

	ldx cnt+1
	beq l2

	ldy #0

l1	lda (src),y
	sta (dst),y
	
	iny
	bne l1

	inc src+1
	inc dst+1
	dex

	bne l1

l2	ldy cnt
	beq stop

	ldy #0

l3	lda (src),y
	sta (dst),y

	iny
	cpy cnt
	bne l3

stop	ldx #0
@sp	equ *-1

	rts
.endp


; Ullrich von Bassewitz, 29.05.1998
; Performance increase (about 20%) by
; Christian Krueger, 12.09.2009, slightly improved 12.01.2011

.proc	@fill (.word ptr1, ptr3 .byte ptr2) .var

ptr1 = edx
ptr3 = ecx
ptr2 = eax

	ldx ptr2

	ldy #0

        lsr	ptr3+1          ; divide number of
        ror	ptr3            ; bytes by two to increase
        bcc	evenCount       ; speed (ptr3 = ptr3/2)
oddCount:
				; y is still 0 here
        txa			; restore fill value
        sta	(ptr1),y	; save value and increase
        inc	ptr1		; dest. pointer
        bne	evenCount
        inc	ptr1+1
evenCount:
	lda	ptr1		; build second pointer section
	clc
	adc	ptr3		; ptr2 = ptr1 + (length/2) <- ptr3
	sta     ptr2
	lda     ptr1+1
	adc     ptr3+1
	sta     ptr2+1

        txa			; restore fill value
        ldx	ptr3+1		; Get high byte of n
        beq	L2		; Jump if zero

; Set 256/512 byte blocks
				; y is still 0 here
L1:	.rept 2		; Unroll this a bit to make it faster
	sta	(ptr1),y	; Set byte in lower section
	sta	(ptr2),y	; Set byte in upper section
	iny
	.endr
        bne	L1
        inc	ptr1+1
        inc	ptr2+1
        dex                     ; Next 256 byte block
        bne	L1              ; Repeat if any

; Set the remaining bytes if any

L2:	ldy	ptr3            ; Get the low byte of n
	beq	leave           ; something to set? No -> leave

L3:	dey
	sta	(ptr1),y	; set bytes in low
	sta	(ptr2),y	; and high section
	bne     L3		; flags still up to date from dey!
leave:  
	rts			; return
.endp

/*
.proc	@fill (.word dst .byte lcnt, hcnt .byte value) .var

	ldy #0

	lda #0
value	equ *-1

	ldx #0
hcnt	equ *-1
	beq l2

l1	sta $ffff,y
dst	equ *-2
	iny
	bne l1

	inc dst+1
	dex
	bne l1

l2	mwx dst dst2

	ldy #0
lcnt	equ *-1
	beq stop

l3	dey
	sta $ffff,y
dst2	equ *-2
	bne l3
	
stop	rts
.endp
*/


/*
	Reset(f, record)
	Rewrite(f, record)
*/

.proc	@openfile (.word ya .byte x) .reg

	sta bp2
	sty bp2+1

	stx code

	ldy #s@file.eof
	lda #false
	sta (bp2),y

	ldy #s@file.pfname
	lda (bp2),y
	add #1
	sta lfname
	iny
	lda (bp2),y
	adc #0
	sta hfname

	jsr lookup
	bmi ok

	ldy #s@file.chanel
	txa
	sta (bp2),y		;CHANNEL

; -----------------------------------------

	lda #$03		;komenda: OPEN
	sta iccmd,x
	lda #$00		;adres nazwy pliku
lfname	equ *-1
	sta icbufa,x
	lda #$00
hfname	equ *-1
	sta icbufa+1,x
	lda #$00		;kod dostpu: $04 odczyt, $08 zapis, $09 dopisywanie, $0c odczyt/zapis, $0d odczyt/dopisywanie
code	equ *-1
	sta icax1,x
	lda #$00		;dodatkowy parametr, $00 jest zawsze dobre
	sta icax2,x 
	jsr ciov
	
	sty MAIN.SYSTEM.IOResult

	bpl ok

	ldy #s@file.eof
	lda #true
	sta (bp2),y

	ldy #s@file.record
	lda #$00
	sta (bp2),y
	iny
	sta (bp2),y

ok	rts

; -----------------------------------------

lookup	ldx #$00
	ldy #$01
loop	lda icchid,x
	cmp #$ff
	beq found
	txa
	clc
	adc #$10
	tax
	bpl loop
	ldy #-95       		;kod bdu "TOO MANY CHANNELS OPEN"
found	rts
.endp


/*
	Close(f)
*/

.proc	@closefile (.word ya) .reg
	sta	bp2
	sty	bp2+1

	ldy	#s@file.eof
	lda	#true
	sta	(bp2),y

	ldy	#s@file.chanel
	lda	(bp2),y
	tax

	lda	#$0c		;komenda: CLOSE
	sta	iccmd,x
	jsr	ciov

	sty	MAIN.SYSTEM.IOResult

	rts
.endp


/*
	BlockRead(f, buf, num_records, numread)
	BlockWrite(f, buf, num_records, numwrite)
*/

.proc	@readfile (.word ya .byte x) .reg

	sta	bp2
	sty	bp2+1

	stx	code

	lda	#$00
	sta	eax+2
	sta	eax+3
	sta	ecx+2
	sta	ecx+3

	sta	MAIN.SYSTEM.IOResult

	ldy	#s@file.record
	mwa	(bp2),y	ecx

	ldy	#s@file.nrecord
	mwa	(bp2),y	eax

	jsr	imulCX			; record * nrecord = file length to load

	cpw	eax #0
	beq	nothing

	ldy	#s@file.chanel
	lda	(bp2),y
	tax

	mwa	eax	icbufl,x

	ldy	#s@file.buffer
	mwa	(bp2),y	icbufa,x

	lda	#$00
code	equ *-1
	and	#$7f
	sta	iccmd,x

	jsr	ciov

	sty	MAIN.SYSTEM.IOResult

	bpl ok

	cpy #136
	beq done

	jsr eof

	lda #$00
	sta eax
	sta eax+1

	jmp nothing

done	jsr eof

ok	mwa icbufl,x	eax
	ldy #s@file.record
	mwa (bp2),y	ecx

	lda #$00
	jsr idivAX_CX.main

nothing	lda code
	bpl quit			; blockread(f, buf, len)   short version

	ldy #s@file.numread
	mwa (bp2),y ztmp

	ldy #0
	mwa eax (ztmp),y		; length of loaded data / record = number of records
	
quit	rts

eof	ldy #s@file.eof
	lda #true
	sta (bp2),y

	rts
.endp


.proc	@ReadDirFileName (.word ya) .reg

	ldx #5
	jsr @readfile	; (ya, x)

	ldy eax

	lda MAIN.SYSTEM.IOResult
	smi
	lda #0

	rts
.endp


.proc	@DirFileName

	lda #0
	cpy #$12
	bne stop

	ldy #1
	ldx #2
	lda #10
	jsr cpName

	ldx #10
	lda @buf,x
	beq stp2

	lda #'.'
	sta (bp2),y
	iny

	lda #13
	jsr cpName
stp2
	dey
	tya
stop	ldy #0
	sta (bp2),y

	rts

cpName	sta ln
cp	lda @buf,x
	cmp #' '
	beq stp
	sta (bp2),y
	iny
	inx
	cpx #0
ln	equ *-1
	bne cp
stp	rts
.endp


/*
 add strings
 result -> @buf
*/
.proc	@addString(.word ya) .reg

	sta ztmp
	sty ztmp+1

	stx @sp

	ldy #0
	lda (ztmp),y
	sta ile

	ldx @buf
	inx
	beq stop

	iny

load	lda (ztmp),y
	sta @buf,x

	iny
	inx
	beq stop
	dec ile
	bne load

stop	dex
	stx @buf

	ldx #0
@sp	equ *-1
	rts

ile	brk
.endp


.proc	@AllocMem(.word ztmp .word ztmp+2) .var

	jsr swap

	adw spoint ztmp+2

	rts

swap	txa:pha

	mwa spoint bp2

	ldx #0
	ldy #0

loop	cpy ztmp+2
	bne @+
	cpx ztmp+3
	beq stop

@	lda (bp2),y
	pha

	lda (ztmp),y
	sta (bp2),y

	pla
	sta (ztmp),y

	iny
	bne loop

	inc ztmp+1
	inc bp2+1
	inx

	jmp loop

stop	pla:tax

	rts

spoint	dta a(PROGRAMSTACK)
.endp


.proc	@FreeMem(.word ztmp .word ztmp+2) .var

	sbw @AllocMem.spoint ztmp+2

	jmp @AllocMem.swap
.endp


;
; 2009 by KMK/DLT
;

.proc	@vbxe_detect

MEMAC_B_CTL = $5d

	lda #$d6
	sta _vbxe_write+2
	ldy #MEMAC_B_CTL
	jsr clr

	jsr try
	bcc ret

	inc _vbxe_write+2

try	ldx $4000
	jsr chk
	bcc ret
	inx
	stx $4000
	jsr chk
	dec $4000
ret	rts

chk	lda #$80
	jsr _vbxe_write
	cpx $4000
	bne fnd
	sec
	.byte $24
fnd	clc
clr	lda #$00
_vbxe_write
	sta $d600,y
	rts
.endp


.proc	@vbxe_reset

	ldy #$5d ; MEMB
	lda #0
	jsr @vbxe_detect._vbxe_write
	
	ldy #$40 ; VIDEO_CONTROL
	lda #0
	jsr @vbxe_detect._vbxe_write

	mva #$22 $22f ; normal screen

	rts
.endp


.proc	@vbxe_init

	lda #$80				; enable VBXE BANK #0 MEM = $4000..$7FFF
	ldy #FX_MEMB
	jsr @vbxe_detect._vbxe_write

	ldx #.sizeof(s@xdlc)-1
	mva:rpl xdlist,x $4000,x-

	lda colpf1s
	and #$0f
	sta colpf1s

	mva #$41 bp2+1
	ldy #$00
	sty bp2
	tya

lop	sta (bp2),y
	iny
	mva colpf1s (bp2),y
	iny
	mva colpf2s (bp2),y
	iny
	mva #$00 (bp2),y

	iny
	bne lop

	inc bp2+1
	bpl lop

;	lda #$00			; disable VBXE BANK #0 MEM = $4000..$7FFF
	ldy #FX_MEMB
	jsr @vbxe_detect._vbxe_write

	sta colpf0s

	ldy #FX_XDL_ADR0		; XDLIST PROGRAM ADDRES = bank #0
	jsr @vbxe_detect._vbxe_write 
	ldy #FX_XDL_ADR1
	jsr @vbxe_detect._vbxe_write
	ldy #FX_XDL_ADR2
	jsr @vbxe_detect._vbxe_write

	mwa #@vbxe_cmap @putchar.vbxe+1
	mva #{jsr*} @putchar.vbxe

	lda #VC_XDL_ENABLED|VC_XCOLOR
	ldy #FX_VIDEO_CONTROL
	jmp @vbxe_detect._vbxe_write

xdlist	dta s@xdlc [0] (XDLC_END|XDLC_RPTL|XDLC_MAPON|XDLC_MAPADR|XDLC_MAPPAR|XDLC_OVATT, 240-1, $100, $100, 0, 0, 7, 7, 1, 0)

.endp


.proc	@vbxe_cmap

	pha

	cmp #eol
	beq stop

	cmp #$7d		; clrscr
	bne skp

	jsr @vbxe_init
	jmp stop

skp	lda #$80
	ldy #FX_MEMB
	jsr @vbxe_detect._vbxe_write

	lda rowcrs
	add #$44
	sta bp+1

	lda colcrs
	asl @
	asl @
	tay
	mva colpf0s (bp),y
	iny
	mva colpf1s (bp),y
	iny
	mva colpf2s (bp),y

	lda #$00
	ldy #FX_MEMB
	jsr @vbxe_detect._vbxe_write

stop	pla

	rts
.endp

