
program FractalTree;

uses crt, graph, windows;

const	SplitProportion=0.22; 
	cosphi         =0.939692620791;
	sinphi         =0.342020143326;
	maxlevel       =8;
	maxtab         =20;
	Xmax           =319;
	Ymax           =191;

var   i     :byte;
      mx    ,
      my    ,
      dx    ,
      dy    : real;
      tab   : array [0..maxtab] of real;

procedure split(sx, sy, ex, ey:real; level:byte );

  var midx    ,
      midy    ,
      oldlen  ,
      newlen  ,
      costheta,
      sintheta: real;

  begin
    midx    :=(sx+ex)/2.0;
    midy    :=(sy+ey)/2.0;
    dx      :=ex-sx;
    dy      :=ey-sy;
    oldlen  :=tab[level-1]*150.0 ;
    newlen  :=tab[level]  *150.0;
    costheta:=dx/oldlen;
    sintheta:=dy/oldlen;

    MoveTo(trunc(sx  ),trunc(IntToReal(ymax)-sy  ));
    LineTo(trunc(midx),trunc(IntToReal(ymax)-midy));

    if level < maxlevel then begin
      split(midx, midy
         ,newlen*(costheta*cosphi-
                  sintheta*sinphi)+midx
         ,newlen*(sintheta*cosphi+
                  costheta*sinphi)+midy
          ,level+1);

      split(midx, midy
         ,newlen*(costheta*cosphi+
                  sintheta*sinphi)+midx
         ,newlen*(sintheta*cosphi-
                  costheta*sinphi)+midy
         ,level+1);
      end;
  end;

begin

  InitGraph(8);

  SetColor(1);

  tab[0]:=3.0;

  for i := 1 to maxtab do
    tab[i]:=SplitProportion*tab[0];

  mx := IntToReal(Xmax) / 2.0;
  my := IntToReal(Ymax) / 2.0;

  split(mx, 0.0, mx, my, 1);

  repeat until keypressed;

end.




