// Eratosthenes Sieve benchmark

uses windows, crt;

const
 size = 8191;
 iter_max = 10;

var 
  flags: array [0..size] of boolean;

  i, iter, k, prime, count: word;

  starttime: cardinal;

begin

	writeln(iter_max,' iterations');

	starttime := GetTickCount;
	
	iter := 1;
	while iter <= iter_max do begin

		i:=0;
		count := 0;

		fillchar(flags, sizeof(flags), true);

		while i <= size do begin

			if flags[i] then begin

				prime := i shl 1 + 3;
				k := i + prime;

				while (k <= size) do begin
					flags[k] := false;
					inc(k, prime);
				end;
				inc(count);
			end;

		inc(i);
		end;

	inc(iter);
	end;

 writeln(count, ' primes');
 writeln(GetTickCount - starttime, ' tick');	

 repeat until keypressed;

end.
