// VBXE Color Map Graphics

uses crt, graph;

const
	charsets = $8000;

var f: file;
    p: ^byte;
    chrAdr, i: byte;

    
procedure vbl; interrupt; assembler;
asm
{	mva >charsets chrAdr

	jmp xitvbv
};
end;


procedure dli; interrupt; assembler;
asm
{	pha

	lda chrAdr
	sta wsync
	sta chbase

	add #4
	sta chrAdr
	
	pla
};
end;


begin

 InitGraph(vbxe, 12, '');
 
 if GraphResult <> grOK then begin
  writeln('VBXE not detected');

  writeln(#$9b'Press any key');
  repeat until keypressed;
 
  halt;
 end; 

 p:=pointer(dpeek(88));
 assign(f, 'D:DONTTURN.SCR'); reset(f, 1);
 blockread(f, p, 40*24);
 close(f);

 p:=pointer(charsets);
 assign(f, 'D:DONTTURN.FNT'); reset(f, 1);
 blockread(f, p, 1024*8);
 close(f);

 SetVideoBank($80);

 p:=pointer($4400);
 assign(f, 'D:DONTTURN.CMP'); reset(f, 1);
 for i:=0 to 23 do begin 
  blockread(f, p, 160);
  inc(p, $100);
 end;
 close(f);

 SetVideoBank(0);

 intr(iVBL, @vbl);

 intr(iDLI, @dli);

 p:=pointer(dpeek($230)+2);
 
 p^:=$f0;

 inc(p, 5);
 
 for i:=0 to 6 do begin
  p^:=$84;
  inc(p, 3);
 end;
 
 poke($d40e, $c0);
 
 SetBkColor(6);

 repeat until keypressed;
 
end.

