// plasma by groepaz/hitmen
// vbxe plasma 4x4

uses graph, crt;

const
    sinustable: array [0..255] of byte = (
    $80, $7d, $7a, $77, $74, $70, $6d, $6a,
    $67, $64, $61, $5e, $5b, $58, $55, $52,
    $4f, $4d, $4a, $47, $44, $41, $3f, $3c,
    $39, $37, $34, $32, $2f, $2d, $2b, $28,
    $26, $24, $22, $20, $1e, $1c, $1a, $18,
    $16, $15, $13, $11, $10, $0f, $0d, $0c,
    $0b, $0a, $08, $07, $06, $06, $05, $04,
    $03, $03, $02, $02, $02, $01, $01, $01,
    $01, $01, $01, $01, $02, $02, $02, $03,
    $03, $04, $05, $06, $06, $07, $08, $0a,
    $0b, $0c, $0d, $0f, $10, $11, $13, $15,
    $16, $18, $1a, $1c, $1e, $20, $22, $24,
    $26, $28, $2b, $2d, $2f, $32, $34, $37,
    $39, $3c, $3f, $41, $44, $47, $4a, $4d,
    $4f, $52, $55, $58, $5b, $5e, $61, $64,
    $67, $6a, $6d, $70, $74, $77, $7a, $7d,
    $80, $83, $86, $89, $8c, $90, $93, $96,
    $99, $9c, $9f, $a2, $a5, $a8, $ab, $ae,
    $b1, $b3, $b6, $b9, $bc, $bf, $c1, $c4,
    $c7, $c9, $cc, $ce, $d1, $d3, $d5, $d8,
    $da, $dc, $de, $e0, $e2, $e4, $e6, $e8,
    $ea, $eb, $ed, $ef, $f0, $f1, $f3, $f4,
    $f5, $f6, $f8, $f9, $fa, $fa, $fb, $fc,
    $fd, $fd, $fe, $fe, $fe, $ff, $ff, $ff,
    $ff, $ff, $ff, $ff, $fe, $fe, $fe, $fd,
    $fd, $fc, $fb, $fa, $fa, $f9, $f8, $f6,
    $f5, $f4, $f3, $f1, $f0, $ef, $ed, $eb,
    $ea, $e8, $e6, $e4, $e2, $e0, $de, $dc,
    $da, $d8, $d5, $d3, $d1, $ce, $cc, $c9,
    $c7, $c4, $c1, $bf, $bc, $b9, $b6, $b3,
    $b1, $ae, $ab, $a8, $a5, $a2, $9f, $9c,
    $99, $96, $93, $90, $8c, $89, $86, $83
    );

    _palete: array [0..255] of byte = (
    $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01,$00,
    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$2F,$2E,$2D,$2C,$2B,$2A,$29,$28,$27,$26,$25,$24,$23,$22,$21,$20,
    $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$4F,$4E,$4D,$4C,$4B,$4A,$49,$48,$47,$46,$45,$44,$43,$42,$41,$40,
    $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$6F,$6E,$6D,$6C,$6B,$6A,$69,$68,$67,$66,$65,$64,$63,$62,$61,$60,
    $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,$8F,$8E,$8D,$8C,$8B,$8A,$89,$88,$87,$86,$85,$84,$83,$82,$81,$80,
    $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,$AF,$AE,$AD,$AC,$AB,$AA,$A9,$A8,$A7,$A6,$A5,$A4,$A3,$A2,$A1,$A0,
    $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,$CF,$CE,$CD,$CC,$CB,$CA,$C9,$C8,$C7,$C6,$C5,$C4,$C3,$C2,$C1,$C0,
    $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$EF,$EE,$ED,$EC,$EB,$EA,$E9,$E8,$E7,$E6,$E5,$E4,$E3,$E2,$E1,$E0
    );
    
    charsets = $8000;

var
    chradr, i: byte;
    c1A,c1B: byte;
    c2A,c2B: byte;

    p: ^byte;
    
    xbuf: array [0..47] of byte;
    ybuf: array [0..47] of byte;
   
    cmap: array [0..255] of byte absolute $0600; 


procedure doplasma;
var _c1a, _c1b: byte;
    _c2a, _c2b: byte;
    i, j, ii, tmp: byte;
    scrn: ^byte;
    map: word;
begin

    _c1a := c1A;
    _c1b := c1B;
    
    for ii := 0 to high(ybuf) do begin
        ybuf[ii] := word(sinustable[_c1a] + sinustable[_c1b]) shr 2;
        inc(_c1a, 3);
        inc(_c1b, 5);
    end;
    inc(c1A, 2);
    dec(c1B, 3);

    _c2a := c2A;
    _c2b := c2B;

    for i := 0 to high(xbuf) do begin
        xbuf[i] := word(sinustable[_c2a] + sinustable[_c2b]) shr 2;
        inc(_c2a, 1);
        inc(_c2b, 3);
    end;
    inc(c2A, 3);
    dec(c2B, 1);
    
    map := $4700 + 80 - 16;
    
    for ii := 0 to high(ybuf) do begin

	scrn := pointer(map);
{    
	tmp := ybuf[ii];
	
	j:=0;

	for i := 0 to 19 do begin
            scrn^ := byte(xbuf[j] + tmp);
	    inc(scrn);
	    inc(j);

            scrn^ := byte(xbuf[j] + tmp);
	    inc(scrn,3);
	    inc(j);
	end;
}

asm
{	txa:pha

	lda scrn
	sta adr0
	sta adr1

	lda scrn+1
	sta adr0+1
	sta adr1+1

	ldy ii
	lda adr.ybuf,y
	sta t0
	sta t1

	ldx #47
	ldy #0

lp	lda adr.xbuf,x
	adc #0
t0	equ *-1
	sta c0

	lda adr.cmap
c0	equ *-2

	sta $ffff,y
adr0	equ *-2
	iny

	dex
	lda adr.xbuf,x
	adc #0
t1	equ *-1
	sta c1

	lda adr.cmap
c1	equ *-2

	sta $ffff,y
adr1	equ *-2

	iny
	iny
	iny

	dex
	bpl lp

	inc map+1

	pla:tax
};

//	inc(map, $100);	
    end;

end;


procedure vbl; interrupt; assembler;
asm
{	mva >charsets chrAdr

	jmp xitvbv
};
end;


procedure dli; interrupt; assembler;
asm
{	pha

	lda chrAdr
	sta wsync
	sta chbase

	add #4
	sta chrAdr
	
	pla
};
end;


procedure Init;
var i: byte;
    ptr: ^byte;
    adr: word;
begin

 chradr:=hi(charsets);

 ptr:=pointer(dpeek(88));
 
 for i:=0 to 119 do begin
  ptr^:=i;
  inc(ptr);
 end;

 ptr:=pointer(dpeek(88));
 adr:=dpeek(88)+120;
 
 for i:=0 to 7 do begin
  move(ptr, pointer(adr), 120);
  inc(adr, 120);
 end; 

 adr:=charsets;

 for i:=0 to 7 do begin
 
  ptr:=pointer(adr+16*8); 
  fillchar(ptr, 192, %01011010);

  ptr:=pointer(adr+56*8); 
  fillchar(ptr, 192, %01011010);

  ptr:=pointer(adr+96*8); 
  fillchar(ptr, 192, %01011010);

  inc(adr, 1024);
 end;

 for i:=0 to 255 do cmap[i] := _palete[i];

end;


procedure LoadVMC;
var p :pointer;
    f: file;
begin

 p:=pointer(charsets);
 assign(f, 'D:BLINKYS.FNT'); reset(f, 1);
 blockread(f, p, 1024*8);
 close(f);

 SetVideoBank($80);

 p:=pointer($4700);
 assign(f, 'D:BLINKYS.CMP'); reset(f, 1);
 for i:=0 to 23 do begin 
  blockread(f, p, 160);
  move(p, pointer(word(p)+$100), $100);
  inc(p, $200);
 end;
 close(f);

 SetVideoBank(0);
end;


begin

 InitGraph(vbxe, 12, '');
 
 if GraphResult <> grOK then begin
  writeln('VBXE not detected');

  writeln(#$9b'Press any key');
  repeat until keypressed;
 
  halt;
 end; 
  
 SetColorMap(8,4);

 LoadVMC;

 Init;

 intr(iVBL, @vbl);

 intr(iDLI, @dli);

 p:=pointer(dpeek($230)+2);
 
 p^:=$f0;

 inc(p, 5);
 
 for i:=0 to 6 do begin
  p^:=$84;
  inc(p, 3);
 end;
 
 poke($d40e, $c0);

 randomize;
 
 c1A := random(256);
 c1B := random(256);
 c2A := random(256);
 c2B := random(256);
 
 SetVideoBank($80);

 repeat

 doplasma;
 
 until keypressed;

 SetVideoBank(0);

end.

