unit math;

{

http://www.freepascal.org/docs-html/rtl/math/index-5.html

ArcCos
ArcSin
Floor
FMod
Max
Min
Power
Tan

}

interface


implementation


function Min(x, y: Real): Real; overload;
//----------------------------------------------------------------------------------------------
// Return smallest of two values
//----------------------------------------------------------------------------------------------
begin
if x < y then Result := x else Result := y;
end;


function Min(x, y: Integer): Integer; overload;
begin
if x < y then Result := x else Result := y;
end;


function Max(x, y: Real): Real; overload;
//----------------------------------------------------------------------------------------------
// Return largest of two values
//----------------------------------------------------------------------------------------------
begin
if x > y then Result := x else Result := y;
end;


function Max(x, y: Integer): Integer; overload;
begin
if x > y then Result := x else Result := y;
end;


function Power(a: real; n: integer): real; overload;
//----------------------------------------------------------------------------------------------
// Power returns the value of base to the power expon.
//----------------------------------------------------------------------------------------------
begin

 Result := 1.0;
 
 while n do 
  if n mod 2=1 then begin
   Result := Result * a;
   a:= a * a;
   n:=n shr 1;
  end; 
 
end;


function Power(a, n: integer): integer; overload;
begin
  
 Result := 1;
 
 while n do 
  if n mod 2=1 then begin
   Result := Result * a;
   a:= a * a;
   n:=n shr 1;
  end; 

end;


function ArcSin(x: real): real;
const
 a0 = D_PI_2;
 a1 = -0.212;
 a2 = 0.074;
 a3 = -0.019;

begin

 if (x>=-1.0) and (x<=1.0) then 
  Result:= a0 - sqrt(1.0 - x)*(a0 + a1*x + a2*x*x + a3*x*x*x);
  
end;


function ArcCos(x: real): real;
begin

 if (x>=-1.0) and (x<=1.0) then 
  Result:= D_PI_2 - ArcSin(x);
  
end;


function Tan(x: Real): Real;
begin

 Result := sin(x) / cos(x);

end;


function Floor(fp: real): smallint;
var i: integer;
begin

 Result := trunc(fp + 32768.) - 32768;

end;


function FMod(a,b:real): real;
begin

 Result := (a - b * IntToReal(floor(a / b)));

end;



end.

